import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.SwingUtilities;


public class cardLayout
{
	static class MyFrame extends JFrame implements ActionListener
	{
		private static final long serialVersionUID = 1L;
		
		CardLayout layout = new CardLayout();

		JButton firstButton = new JButton("First");
		JButton nextButton = new JButton("Next");
		JButton previousButton = new JButton("Previous");
		JButton lastButton = new JButton("Last");
		JPanel centerPanel = new JPanel();
		
		MyFrame()
		{
			super("CardLayout Beispiel");
			
			Container c = super.getContentPane(); 
			c.setLayout(new BorderLayout());
			
			{// Buttons
				JPanel buttonPanel = new JPanel();
				buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.LINE_AXIS)); // horizontales BoxLayout
				
				firstButton.addActionListener(this);
				nextButton.addActionListener(this);
				previousButton.addActionListener(this);
				lastButton.addActionListener(this);
				
				buttonPanel.add(firstButton);
				buttonPanel.add(nextButton);
				buttonPanel.add(previousButton);
				buttonPanel.add(lastButton);	
				
				c.add(buttonPanel, BorderLayout.NORTH);
			}
			{ // CenterPanel
				centerPanel.setLayout(layout);
				
				centerPanel.add(new JButton("Lorem Ipsum"), "Button");
				centerPanel.add(new JRadioButton("Lorem Ipsum"), "RadioButton");
				centerPanel.add(new JCheckBox("Lorem Ipsum"), "CheckBox");
				centerPanel.add(new JLabel("Lorem Ipsum"), "Label");
				centerPanel.add(new JToggleButton("Lorem Ipsum"), "ToggleButton");
				centerPanel.add(new JTextField("Lorem Ipsum"), "TextField");
				centerPanel.add(new JSpinner(), "Spinner");
				
				c.add(centerPanel, BorderLayout.CENTER);
			}
			
		}

		@Override
		public void actionPerformed(ActionEvent e) 
		{
			if(e.getSource() == firstButton)
				layout.first(centerPanel);
			else if(e.getSource() == previousButton)
				layout.previous(centerPanel);
			else if(e.getSource() == nextButton)
				layout.next(centerPanel);
			else if(e.getSource() == lastButton)
				layout.last(centerPanel);
			
		}
		
	}
	
	public static void main(String[] a)
	{
		JFrame.setDefaultLookAndFeelDecorated(true); 
		SwingUtilities.invokeLater(new Runnable()
		{
			@Override
			public void run() 
			{
				MyFrame f = new MyFrame();
				f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				f.setVisible(true);
			}			
		}
				
		);
	}
	
	
}