import java.awt.Color;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JSpinner;
import javax.swing.SwingUtilities;

public class dialoge
{
	static class MyFrame extends JFrame
	{
		private static final long serialVersionUID = 1L;

		
		MyFrame()
		{
			super("Dialoge Beispiel");
			
			Container c = super.getContentPane(); 
			c.setLayout(new BoxLayout(c, BoxLayout.PAGE_AXIS));
			
			final JButton inputDialogButton = new JButton("Input Dialog");
			JButton messageDialogButton = new JButton("Message Dialog");
			final JButton optionDialogButton = new JButton("Option Dialog");
			final JButton confirmDialogButton = new JButton("Confirm Dialog");
			final JButton colorButton = new JButton("Color Chooser");
			final JButton fileButton = new JButton("File Chooser");
			final JButton dialogButton = new JButton("Custom Dialog");
			
			
			c.add(inputDialogButton);
			c.add(messageDialogButton);
			c.add(optionDialogButton);
			c.add(confirmDialogButton);
			c.add(colorButton);
			c.add(fileButton);
			c.add(dialogButton);

			inputDialogButton.addActionListener(new ActionListener()
			{
				@Override
				public void actionPerformed(ActionEvent e) {
					String in = JOptionPane.showInputDialog(MyFrame.this, "Input Dialog");
					inputDialogButton.setText(in);
				}
			});
			messageDialogButton.addActionListener(new ActionListener()
			{
				@Override
				public void actionPerformed(ActionEvent e) {
					JOptionPane.showMessageDialog(MyFrame.this, "Message Dialog");
				}
			});
			optionDialogButton.addActionListener(new ActionListener()
			{
				@Override
				public void actionPerformed(ActionEvent e) {
					String[] optionen = {"Eis", "Kuchen", "Erdbeeren" };
					int o = JOptionPane.showOptionDialog(MyFrame.this, 
							"Waehle", // nachricht 
							"Option Dialog",  // titel
							JOptionPane.YES_NO_OPTION,  // buttons
							JOptionPane.INFORMATION_MESSAGE,  //icon
							null,  // eigenes icon?
							optionen,
							"Eis");
					if(o != JOptionPane.CLOSED_OPTION) // wurde was gewaehlt?
						optionDialogButton.setText(optionen[o]);
					
				}
			});
			
			
			confirmDialogButton.addActionListener(new ActionListener()
			{
				@Override
				public void actionPerformed(ActionEvent e) {
					int in = JOptionPane.showConfirmDialog(MyFrame.this, "Confirm Dialog");
					confirmDialogButton.setText("" + in);
				}
			});
			
			colorButton.addActionListener(new ActionListener()
			{
				@Override
				public void actionPerformed(ActionEvent e) {
					Color c = JColorChooser.showDialog(MyFrame.this, "Color Chooser", null);
					if(c != null)
						colorButton.setText(c.toString());
				}
			});
			
			fileButton.addActionListener(new ActionListener()
			{
				@Override
				public void actionPerformed(ActionEvent e) {
					JFileChooser fc = new JFileChooser();
					int ret = fc.showOpenDialog(MyFrame.this); // Datei oeffnen
					if(ret == JFileChooser.APPROVE_OPTION) // Hat der Benutzer auf OK gedrueckt?
					{
						fileButton.setText(fc.getSelectedFile().getName());
					}
				}
			});
			
			dialogButton.addActionListener(new ActionListener()
			{
				
				@SuppressWarnings("serial")
				class MyDialog extends JDialog
				{
					private JSpinner value = new JSpinner();
					private JButton trigger = new JButton("OK");
					MyDialog(JFrame parent)
					{
						super(parent, "Mein Dialog", true); // damit es modal werden kann

						Container c = super.getContentPane(); 
						c.setLayout(new BoxLayout(c, BoxLayout.PAGE_AXIS));
						
						c.add(value);
						c.add(trigger);
						
						trigger.addActionListener(new ActionListener() {
							@Override
							public void actionPerformed(ActionEvent e) {
								setVisible(false); // verstecken
								dispose(); // entfernen
							}
						});
						
						pack();
					}
					public int getValue() { return (Integer) value.getValue(); }
				}
				
				@Override
				public void actionPerformed(ActionEvent e) {
					MyDialog d = new MyDialog(MyFrame.this);
					d.setVisible(true);
					dialogButton.setText("" + d.getValue());
				}
			});
			
			
		}
		
	}
	
	public static void main(String[] a)
	{
		JFrame.setDefaultLookAndFeelDecorated(true); 
		SwingUtilities.invokeLater(new Runnable()
		{
			@Override
			public void run() 
			{
				MyFrame f = new MyFrame();
				f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				f.setVisible(true);
			}			
		}
				
		);
	}
	
	
}