import java.awt.Color;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
import javax.swing.SwingUtilities;


public class doubleBuffering 
{
	
	static class MyPanel extends JPanel implements Runnable

	{
		private static final long serialVersionUID = 1L;
		
		BufferedImage bild = new BufferedImage(400,300, BufferedImage.TYPE_INT_ARGB);
		int x = 50;
		int y = 50;
		
		MyPanel()
		{
			super.setDoubleBuffered(true);
			Graphics g = bild.getGraphics();
			g.setColor(new Color(255,255,255));
			g.fillRect(0, 0, bild.getWidth(), bild.getHeight());
		}
		
		
		@Override
		public void paintComponent(Graphics g)
		{
			g.drawImage(bild, 0, 0, null);
		}
		

		@Override
		public void run() 
		{
			try 
			{
				while(true)
				{
					x += (int) ( (Math.random() * 3)) - 1 ;
					y += (int) ( (Math.random() * 3)) - 1 ;
					Graphics g = bild.getGraphics();
					g.setColor(new Color(255,255,255));
					g.fillRect(x-5, y-5, 60, 60);
					g.setColor(new Color(92,255,92));
					g.drawOval(x, y, 50, 50);
					g.setColor(new Color(92,92,255));
					g.fillOval(x, y, 50, 50);
					super.repaint();
					
						Thread.sleep(20);
			
				}
			} 
			catch (InterruptedException e) 
			{
				sleep();
			}
		}
		void sleep()
		{
			try 
			{
				while(true)
				{
					Thread.sleep(200);
				}
			}
			catch (InterruptedException e) 
			{
			}
			run();
		}
	}
	
	static class MyFrame extends JFrame
	{
		private static final long serialVersionUID = 1L;

		
		MyFrame()
		{
			super("Double Buffering");
			
			
			final MyPanel mypanel = new MyPanel();
			
			
			
			JPanel buttonPanel = new JPanel();
			buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.PAGE_AXIS)); 
			JToggleButton startButton = new JToggleButton("Animate");
			buttonPanel.add(startButton);
			
			final Thread t = new Thread(mypanel);
			
			startButton.addActionListener(new ActionListener()
			{

				@Override
				public void actionPerformed(ActionEvent e) 
				{
					if(t.isAlive())
					{
						t.interrupt();
						return;
					}
					t.start();
				}
				
			});
			
			Container c = super.getContentPane(); 
			c.setLayout(new BoxLayout(c, BoxLayout.LINE_AXIS)); 
			c.add(mypanel);
			c.add(buttonPanel);
			
			super.pack();
		}
		
	}
	
	public static void main(String[] a)
	{
		JFrame.setDefaultLookAndFeelDecorated(true); 
		SwingUtilities.invokeLater(new Runnable()
		{
			@Override
			public void run() 
			{
				MyFrame f = new MyFrame();
				f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				f.setVisible(true);
			}			
		}
				
		);
	}

	
	
}