import java.awt.Color;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;


public class images
{
	static class MyPanel extends JPanel
	{
		private static final long serialVersionUID = 1L;
		
		BufferedImage bild = new BufferedImage(400,300, BufferedImage.TYPE_INT_ARGB);
		
		@Override
		public void paintComponent(Graphics g)
		{
			g.drawImage(bild, 0, 0, null);
		}
		
		public void drawPixels()
		{
			for(int x = 0; x < bild.getWidth(); ++x)
				for(int y = 0; y < bild.getHeight(); ++y)
					bild.setRGB(x, y, new Color(x%255,y%255, (x*y) % 255 ).getRGB() );
			super.repaint();
		}
		public void drawLines()
		{
			Graphics g = bild.getGraphics();
			g.setColor(new Color(92,255,92,30));
			g.drawOval(0, 0, bild.getWidth(), bild.getHeight());
			g.setColor(new Color(128,128,255,30));
			g.fillOval(0, 0, bild.getWidth(), bild.getHeight());
			super.repaint();
		}

	}
	
	static class MyFrame extends JFrame
	{
		private static final long serialVersionUID = 1L;

		
		MyFrame()
		{
			super("FlowLayout Beispiel");
			
			
			final MyPanel mypanel = new MyPanel();
			
			
			
			JPanel buttonPanel = new JPanel();
			buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.PAGE_AXIS)); 
			JButton pixelButton = new JButton("Pixels");
			JButton linesButton = new JButton("Lines");
			buttonPanel.add(pixelButton);
			buttonPanel.add(linesButton);
			
			pixelButton.addActionListener(new ActionListener()
			{

				@Override
				public void actionPerformed(ActionEvent e) 
				{
					mypanel.drawPixels();
				}
				
			});
			linesButton.addActionListener(new ActionListener()
			{

				@Override
				public void actionPerformed(ActionEvent e) 
				{
					mypanel.drawLines();
				}
				
			});
			
			Container c = super.getContentPane(); 
			c.setLayout(new BoxLayout(c, BoxLayout.LINE_AXIS)); 
			c.add(mypanel);
			c.add(buttonPanel);
			
			super.pack();
		}
		
	}
	
	public static void main(String[] a)
	{
		JFrame.setDefaultLookAndFeelDecorated(true); 
		SwingUtilities.invokeLater(new Runnable()
		{
			@Override
			public void run() 
			{
				MyFrame f = new MyFrame();
				f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				f.setVisible(true);
			}			
		}
				
		);
	}
	
	
}