import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;


public class scribble_keyfilter
{
	static class ScribblePanel extends JPanel
	{
		private static final long serialVersionUID = 1L;
		
		private BufferedImage bild = null;
		private Point lastPosition;
		private Point textPosition;
		
		
		public void clearImage()
		{
			textPosition = new Point(20,20);
			Graphics g = bild.getGraphics();
			g.setColor(new Color(0,0,50));
			g.fillRect(0, 0, bild.getWidth(), bild.getHeight());
			g.dispose();
			repaint();
		}
		
		public ScribblePanel()
		{
			bild = new BufferedImage(100, 100,  BufferedImage.TYPE_INT_ARGB);
			clearImage();
			
			this.addComponentListener(new ComponentAdapter()
			{
				@Override
				public void componentResized(ComponentEvent e)
				{
					BufferedImage neuesBild = new BufferedImage(ScribblePanel.this.getWidth(), ScribblePanel.this.getHeight(),  BufferedImage.TYPE_INT_ARGB);
					Graphics g = neuesBild.getGraphics();
					// Hintergrund
					g.setColor(new Color(0,0,50));
					g.fillRect(0, 0, neuesBild.getWidth(), neuesBild.getHeight());
					
					// Bildinhalt kopieren:
					g.drawImage(bild, 0, 0, null);
					// Graphicsobjekt loeschen:
					g.dispose();
					bild = neuesBild;
				}
			});
			
			
			this.addMouseMotionListener(new MouseMotionListener()
			{

				@Override
				public void mouseDragged(MouseEvent e) 
				{
					if((e.getModifiersEx() & InputEvent.BUTTON1_DOWN_MASK) != 0)
					{
						if(lastPosition != null)
						{
							Graphics g = bild.getGraphics();
							g.setColor(new Color(255,255,0));
							g.drawLine(lastPosition.x, lastPosition.y, e.getX(), e.getY());
							g.dispose();
							
							// optimieren, damit es fluessig laeuft:
							Rectangle toDraw = new Rectangle(lastPosition);
							toDraw.add(e.getPoint());
							toDraw.grow(5, 5);
							ScribblePanel.this.paintImmediately(toDraw);
							
						}
						lastPosition = new Point(e.getPoint());
						
					}
					
				}

				@Override
				public void mouseMoved(MouseEvent e) {	
					if(lastPosition != null) lastPosition = null;
				}
				
			});
			
			this.addKeyListener(new KeyListener() {

				@Override
				public void keyPressed(KeyEvent e) 
				{
					
					if(e.getKeyCode() == KeyEvent.VK_C && e.isControlDown())
						clearImage();
					else if(e.getKeyCode() == KeyEvent.VK_ENTER)
					{
						textPosition.x = 20;
						textPosition.y += 20;
					}
					else if(e.getKeyCode() == KeyEvent.VK_BACK_SPACE)
					{
						textPosition.x -= 20;
					}
				}

				@Override
				public void keyReleased(KeyEvent e) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void keyTyped(KeyEvent e) 
				{
					if(Character.isISOControl(e.getKeyChar())) return;
					Graphics g = bild.getGraphics();
					g.setColor(new Color(255,0,0));
					g.drawString("" + e.getKeyChar(), textPosition.x, textPosition.y);
					g.dispose();
					
					Rectangle toDraw = new Rectangle(textPosition, new Dimension(20,20));
					toDraw.grow(20, 20);
					ScribblePanel.this.paintImmediately(toDraw);
					
					if(textPosition.x > ScribblePanel.this.getWidth())
					{
						textPosition.x = 20;
						textPosition.y += 20;
					}
					else textPosition.x += 20;
					
				}
				
			});
			
		}
		
		@Override
		public void paintComponent(Graphics g)
		{
			if(bild == null) return;
			g.drawImage(bild, 0, 0, null);
		}

		@Override
		public boolean isFocusable()
		{
			return true;
		}

	}
	
	static class MyFrame extends JFrame
	{
		private static final long serialVersionUID = 1L;

		
		MyFrame()
		{
			super("Scribble KeyFilter Beispiel");
			
			Container c = super.getContentPane(); 
			c.add(new ScribblePanel());
			super.pack();
		}
		
	}
	
	public static void main(String[] a)
	{
		JFrame.setDefaultLookAndFeelDecorated(true); 
		SwingUtilities.invokeLater(new Runnable()
		{
			@Override
			public void run() 
			{
				MyFrame f = new MyFrame();
				f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				f.setVisible(true);
			}			
		}
				
		);
	}
	
	
}